//                                    7C                                      \\
//                                IRTC Entry                                  \\
//                            Summer Round  2001                              \\

//                            by Elias Pschernig                              \\

//                               www.irtc.org                                 \\

//  mail: elias@users.sourceforge.net             web: www.elias.f2s.com/pov  \\

// Sword Include File

#version unofficial megapov 0.7;

#declare m_sword = material {
   texture {
      pigment {
         color rgb <0.9, 0.8, 0.7>
      }
      finish {
         diffuse 0.7
         ambient 0.0
         brilliance 1.2
         specular 1
         roughness 0.01
         reflection 0.6
         metallic
      }
   }
}

#declare m_wood = material {
   texture {
      pigment {
         color rgb <0.8, 0.4, 0.1>
      }
      finish {
         diffuse 0.7
         ambient 0.0
         brilliance 1
         specular 1
         roughness 0.02
      }
   }
}

#declare sword = union {
   intersection {
      sphere {
         0 1
         scale <0.04, 1.3, 0.01>
      }
      plane {
         -y 0
      }
      material { m_sword }
   }
   sphere {
      0 1
      scale <0.15, 0.03, 0.03>
      material { m_wood }
   }
   intersection {
      sphere {
         0 1
         scale <0.04, 0.20, 0.04>
      }
      plane {
         y 0
      }
      material { m_wood }
   }

}

#declare shield = difference {
   intersection {
      sphere {
         0 1
         scale <0.3, 1.5, 0.05>
      }
      plane {
         y 0
      }
      plane {
         z 0
      }
   }
   sphere {
      0 1
      scale <0.3, 1.5, 0.05>
      scale 0.95
   }
   
   material { m_sword }

}

/* POV-Ray Scene File for the Internet Raytracing Competition Summer 2001

 #macro C(X,Y)cylinder{X*x<X,0,-Y/2>.1}#end#macro U(R,X,Y)intersection{torus{.9
 .1}box{-1 0rotate y*R*90}translate<X,0,Y>scale 1-z*.5}#end union{U(0,0,0)U(1,0
 ,0)U(2,-1,-1)U(1,1,0)U(1,1.5,-3)U(1,2,0)U(3,1,0)U(2,2,0)U(0,3,0)U(3,2,.5)C(.1,
 2)C(.8,1)C(.8,-1)C(1.1,1)C(1.9,-1)pigment{rgb 10}rotate x*90translate<-1,0,4>}
 
created by Elias Pschernig elias@users.sourceforge.net*/  